--AH:ScriptId=c78bc31c-dd30-4b53-bb86-be1016ea0cb7;2787
ALTER TABLE [Feeds]
	ADD [DropPath_Text] NVARCHAR(260) NULL

ALTER TABLE [Feeds]
	DROP CONSTRAINT [CK__Feeds__FeedType_Code]

ALTER TABLE [Feeds]
	ADD CONSTRAINT [CK__Feeds__FeedType_Code]
		CHECK ([FeedType_Code] IN ('D', 'C', 'N', 'P'))

CREATE TABLE [NpmPackages]
(
	[Package_Id] INT IDENTITY(1, 1) NOT NULL,
	[Feed_Id] INT NOT NULL,
	[Package_Name] NVARCHAR(200) NOT NULL,
	[Download_Count] INT NOT NULL,

	CONSTRAINT [PK__NpmPackages]
		PRIMARY KEY ([Package_Id]),

	CONSTRAINT [FK__NpmPackages__NpmFeeds]
		FOREIGN KEY ([Feed_Id])
		REFERENCES [Feeds] ([Feed_Id]),

	CONSTRAINT [CK__NpmPackages__Download_Count]
		CHECK ([Download_Count] >= 0),

	CONSTRAINT [UQ__NpmPackages__Package_Name]
		UNIQUE ([Feed_Id], [Package_Name])
)

CREATE TABLE [NpmPackageVersions]
(
	[Package_Id] INT NOT NULL,
	[Version_Text] VARCHAR(200) NOT NULL,

	[PackageJson_Bytes] VARBINARY(MAX) NOT NULL,
	[Download_Count] INT NOT NULL,
	[Published_Date] DATETIME NOT NULL,
	[PackageHash_Bytes] BINARY(20) NOT NULL,

	CONSTRAINT [PK__NpmPackageVersions]
		PRIMARY KEY ([Package_Id], [Version_Text]),

	CONSTRAINT [FK__NpmPackageVersions__NpmPackages]
		FOREIGN KEY ([Package_Id])
		REFERENCES [NpmPackages] ([Package_Id]),

	CONSTRAINT [CK__NpmPackageVersions__Download_Count]
		CHECK ([Download_Count] >= 0)
)

CREATE TABLE [NpmPackageTags]
(
	[Package_Id] INT NOT NULL,
	[Tag_Name] NVARCHAR(200) NOT NULL,
	[Tag_Version] VARCHAR(200) NOT NULL,

	CONSTRAINT [PK__NpmPackageTags]
		PRIMARY KEY ([Package_Id], [Tag_Name]),

	CONSTRAINT [FK__NpmPackageTags__NpmPackageVersions]
		FOREIGN KEY ([Package_Id], [Tag_Version])
		REFERENCES [NpmPackageVersions] ([Package_Id], [Version_Text])
)