EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'RpmPackages_IncrementDownloadCount',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Increments the download count for an RPM package.'
GO

IF OBJECT_ID('[RpmPackages_IncrementDownloadCount]') IS NOT NULL DROP PROCEDURE [RpmPackages_IncrementDownloadCount]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [RpmPackages_IncrementDownloadCount]
(
	@RpmPackageVersion_Id INT
)
AS
BEGIN

SET NOCOUNT ON

	UPDATE [RpmPackageVersions]
	   SET [Download_Count] = [Download_Count] + 1,
	       [LastDownloaded_Date] = GETUTCDATE()
	 WHERE [RpmPackageVersion_Id] = @RpmPackageVersion_Id

END
GO

GRANT EXECUTE ON [RpmPackages_IncrementDownloadCount] TO [ProGetUser_Role]
GO